<?php
    
/* 
 * Plugin OsTicket for generate specific reports.
 * The Plugin follows the GNU (General Public License) 
 * Is free to change, study, redistribute and improve.
*/

/**
 * Description of plugin
 *
 * @author Ricardo Plácido <ricardo at outbox360.com.br>
*/

require_once(INCLUDE_DIR.'/class.plugin.php');
require_once(INCLUDE_DIR.'/class.forms.php');

class ReportsConfig extends PluginConfig {
	function get_options() {
		
		$form_choices = array('0' => '--None--');
		foreach (DynamicForm::objects()->filter(array('type'=>'G')) as $group) 
		{
			$form_choices[$group->get('id')] = $group->get('title');
		}
		return array(
		    'report_backend_enable' => new BooleanField(array(
			    'id'    => 'report_backend_enable',
				'label' => 'Enable Backend',
				'configuration' => array(
				    'desc' => 'Staff backend interface')
			)),
			'report_frontend_enable' => new BooleanField(array(
			    'id'    => 'report_frontend_enable',
				'label' => 'Enable Frontend',
				'configuration' => array(
				    'desc' => 'Client facing interface')
			)),
			'report_custom_form' => new ChoiceField(array(
			    'id'    => 'report_custom_form',
				'label' => 'Custom Form Name',
				'choices' => $form_choices,
				'configuration' => array(
				    'desc' => 'Custom form to use for reports')
			)),
	);
	}
	
	function pre_save(&$config, &$errors) {
		global $msg;
		
		if (!$errors)	
			$msg = 'Configuration update successfully';
		
		return true;
	}
	
}

?>