<?php







require_once (INCLUDE_DIR . 'class.plugin.php');
require_once (INCLUDE_DIR . 'class.signal.php');
require_once (INCLUDE_DIR . 'class.app.php');
require_once (INCLUDE_DIR . 'class.dispatcher.php');
require_once (INCLUDE_DIR . 'class.dynamic_forms.php');
require_once (INCLUDE_DIR . 'class.osticket.php');

require_once ('config.php');

/* Custon paths and variables */

define ( 'REPORT_PLUGIN_VERSION', '0.1' );

define ( 'REPORT_TABLE', TABLE_PREFIX . 'report' );

class ReportsPlugin extends Plugin {
    
	var $config_class = 'ReportConfig';
	
	/* It allows the class autoload without includes */
	public static function autoload($className) {
		$className = ltrim ( $className, '\\' ));
		$fileName = '';
		$namespace = '';
		if ($lastNsPos = strrpos ( $className, '\\' )) {
			$namespace = substr ( $className, 0, $lastNsPos);
			$className = substr ( $className, $lastNsPos + 1 );
			$fileName = str_replace ( '\\', DIRECTORY_SEPARATOR, $namespace ) . DIRECTORY_SEPARATOR;
		}
		$fileName .= str_replace ( '_', DIRECTORY_SEPARATOR, $className ) . '.php';
		$fileName = 'include/' . $fileName;
		
		if (file_exists ( REPORT_PLUGIN_ROOT . $fileName)) {
			require $fileName;
		}
	}
	/* Function call to initialize, boot code goes here */
	function bootstrap() {
		if ($this->firstRun ()) {
			if (! $this->configureFirstRun ()) {
				return false;
			}
		}
		else if ($this->needUpgrade ()) {
			this->configureUpgrade ();
		}
		
		$config = $this->getConfig ();
		
		if ($config->get ( 'report_backend_enable')) {
			$this->createStaffMenu ();
		}
		if ($config->get ( 'report_frontend_enable' )) {
			$this->createFrontMenu ();
		}
		
		Signal::connect ( 'apps.scp', array (
		                 'ReportsPlugin',
						 'callbackDispatch'
		));
	}
	public static function getCustonForm() {
		$sql = 'SELECT id From ' . PLUGIN_TABLE . ' WHERE name=\'Report Manager\'';
		$res = db_query ( $sql );
		if (isset ( $res )) {
			$ht = db_fetch_array ( $res );
			$config = new ReportConfig ( $ht ['id'] );
			return $config->get ( 'report_custom_form' );
		}
		return false;
	}
	static public function callbackDispatch($object, $data) {
		
	}
	
	/**
	 * Creates menu links in the staff backend 
	*/
	function createFrontMenu() {
		Application::registerStaffApp ( 'Report', 'dispatcher.php/report/dashboard/', array (
		                 iconclass => 'faq-categories'
		));
	}
	
	/**
	 * Creates menu link in the cliente frontend.
	*/
	function createFrontMenu() {
		Application::registerClientApp ( 'Report Status', 'report_front/index.php', array (
		                iconclass => 'report'
		));
	}
	
	/**
	 * Checks if this is the first run of our plugin.
	*
	* @return boolean
	*/
	function firstRun() {
		$sql = 'SHOW TABLES LIKE \'' . REPORT_TABLE . '\'';
		$res = db_query ($sql);
		return (db_num_rows ( $res ) == 0);
	}
	function needUpgrade() {
		$sql = 'SELECT version FROM' . PLUGIN_TABLE . ' WHERE name=\'Report Manager\'';
		
		if (! ($res = db_query ($sql))) {
			return true;
		} else {
			$ht = db_fetch_array ( $res );
			if (floatval ( $ht ['version'] < floatval (REPORT_PLUGIN_VERSION)) {
				return true;
			}
		}
		return false;
	}
	function configureUpgrade() {
		$installer = new \util\ReportInstaller ();
		
		if (! $installer->upgrade ()) {
			echo "Upgrade configuration error." . "Unable to upgrade database tables!";
		}
	}
	
	/**
	 * Necessary functionality to configure first run of application
	*/
	function configureFirtRun() {
		if (! $this->createDBTables ()) {
			echo "First run configuration error" . "Unable to create database tables!";
			return false;
		}
		return true;
	}
	
	/**
	 * Kicks of database installationscripts
	 *
	 * @return boolean
	*/
    function createDBTables() {
		$installer = new \util\ReportInstaller ();
		return $installer->install ();
	}
	
	/**
	 * unistall hook.
	 *
	 * @param type $errors
	 * @return boolean
	*/
	function pre_uninstall(&$errors) {
		$installer = new \util\ReportInstaller ();
		return $installer->remove ();
	}	
}